#include "TransactionData.h"

typedef std::vector<int> VECELE;
typedef std::vector<VECELE> MATELE;

using namespace std;

/// Constructeur
TransactionData::TransactionData() :
		m_chemin("../Base/"), cheminFichier1(""), cheminFichier2("") {
}

/// Fonction de lecture du fichier.dat ou .txt et alimente des structures internes
int TransactionData::getData_p(string nom_fichier1) {
	//lire le fichier
	cheminFichier1 = /*m_chemin +*/nom_fichier1;

	ifstream fichier1(cheminFichier1.c_str());
	cout << " getData_p from: "<< cheminFichier1 << endl;
	VECELE vecteur1;

	if (fichier1) {
		while (!fichier1.eof()) {
			string ligne;
			int buffer;
			getline(fichier1, ligne);
			//parser la ligne (string) dans un vector (int)
			stringstream ss(ligne);
			while (ss >> buffer) {
				//converstion explicite de string vers int ss >> buf
				vecteur1.push_back(buffer);
			}
			ss.clear();
			//remplir la matrice vecteur par vecteur
			BDD1.push_back(vecteur1);
			//vider le vecteur
			vecteur1.clear();
		}
	} else {
		cerr << "ERREUR2 : lecture de fichier impossible" << endl;
	}
	fichier1.close();
	return 0;
}

/// Fonction de lecture du fichier.dat ou .txt et alimente des structures internes
int TransactionData::getData_m(string nom_fichier2) {
	//lire le fichier
	cheminFichier2 = /*m_chemin +*/nom_fichier2;

	ifstream fichier2(cheminFichier2.c_str());

	VECELE vecteur2;

	if (fichier2) {
		while (!fichier2.eof()) {
			string ligne;
			int buffer;
			getline(fichier2, ligne);
			//parser la ligne (string) dans un vector (int)
			stringstream ss(ligne);
			while (ss >> buffer) {
				//converstion explicite de string vers int ss >> buf
				vecteur2.push_back(buffer);
			}
			ss.clear();
			//remplir la matrice vecteur par vecteur
			BDD2.push_back(vecteur2);
			//vider le vecteur
			vecteur2.clear();
		}
	} else {
		cerr << "ERREUR3 : lecture de fichier impossible" << endl;
	}
	fichier2.close();
	return 0;
}

/// Accesseur pour BDD 1
const MATELE& TransactionData::getBDD_p() const {
	return BDD1;
}

/// Accesseur pour BDD 2
const MATELE& TransactionData::getBDD_m() const {
	return BDD2;
}

// fonction pour stocker les resultats
int TransactionData::Stocker(VECELE& vect_sortie, int smoins, int splus) {
	// flux de stockage des résultats
	ofstream flux("../Faults/resultat", ios::app);

	for (unsigned int i = 0; i < vect_sortie.size(); i++) {
		flux << vect_sortie[i] << " ";
	}

	for (unsigned int i = 0; i < vect_sortie.size(); i++) {
		if (vect_sortie[i] == 1) {
			flux << "--> Instruction executable n° " << i + 1 << " ( S- = "
					<< smoins << ", S+ = " << splus << ")" << endl;
		}
	}
	flux << "" << endl;
	flux.close();
	return 0;
}

